#include <stdio.h>
#include <windows.h>
#include <tchar.h>

bool displayFile(LPTSTR fileName)
{
	bool result = false;
	HANDLE fileHandle, tempHandle;
	char buffer[MAX_PATH];
	DWORD bytesRead, actualRead;
	TCHAR tempFile[MAX_PATH];
	if ((fileHandle = CreateFile(fileName, GENERIC_WRITE|GENERIC_READ, FILE_SHARE_DELETE, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL))!= INVALID_HANDLE_VALUE)
	{
		_stprintf(tempFile, _T("%s.tmp"), fileName);
		if ((tempHandle = CreateFile(tempFile, GENERIC_WRITE|GENERIC_READ, FILE_SHARE_DELETE, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL))!= INVALID_HANDLE_VALUE)
		{
			printf("before copy file to temp file\n\n");
			while (ReadFile(fileHandle, buffer, MAX_PATH, &bytesRead, NULL) && bytesRead > 0)
			{
				if (!WriteFile(tempHandle, buffer, bytesRead, &actualRead, NULL) || actualRead != bytesRead)
				{
					result = false;
					break;
				}
				result = true;
			}
			CloseHandle(tempHandle);
			
		}
		else
		{
			result = true;
			printf("open temp file failed %d\n", GetLastError());
			while (ReadFile(fileHandle, buffer, MAX_PATH, &bytesRead, NULL) && bytesRead > 0)
			{
				for (int i=0; i< bytesRead; i++)
				{
					printf("%c", buffer[i]);
				}
				
			}			
		}

		CloseHandle(fileHandle);
	}
	else
	{
		printf("create file failed %d\n", GetLastError());
	}
	return result;
}


bool createFile(LPCTSTR fileName)
{
	bool result = false;
	HANDLE fileHandle;
	char buffer[MAX_PATH];
	DWORD bytesRead;
	memset(buffer, 'A', MAX_PATH);
	if ((fileHandle = CreateFile(fileName, GENERIC_WRITE|GENERIC_READ, FILE_SHARE_DELETE, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_ENCRYPTED, NULL))!= INVALID_HANDLE_VALUE)
	{		
		if (WriteFile(fileHandle, buffer, MAX_PATH, &bytesRead, NULL) && bytesRead > 0)
		{
			result = true;	
		}
		
		CloseHandle(fileHandle);
	}
	return result;
}




bool displayToken(HANDLE htok, bool toEnable = false);


// Useful helper function for enabling a single privilege
bool enableTokenPrivilege(HANDLE htok, LPCTSTR szPrivilege, TOKEN_PRIVILEGES& tpOld)
{
	bool result = false;
    TOKEN_PRIVILEGES tp;
    tp.PrivilegeCount = 1;
	DWORD cbOld;
    tp.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED;
	
    if (LookupPrivilegeValue(NULL, szPrivilege, &tp.Privileges[0].Luid))
    {
        // htok must have been opened with the following permissions:
        // TOKEN_QUERY (to get the old priv setting)
        // TOKEN_ADJUST_PRIVILEGES (to adjust the priv)
        cbOld = sizeof(TOKEN_PRIVILEGES);
        if (AdjustTokenPrivileges(htok, FALSE, &tp, cbOld, &tpOld, &cbOld))
            // Note that AdjustTokenPrivileges may succeed, and yet
            // some privileges weren't actually adjusted.
            // You've got to check GetLastError() to be sure!
		{
            result = (ERROR_NOT_ALL_ASSIGNED != GetLastError());
			if (result)
			{
			
			}
		}        
    }
	return result;
}


bool displayToken(HANDLE htok, bool toEnable)
{
	bool result = false, enable;
	LPBYTE buffer[1024];
	DWORD bufferSize = 1024;
	TCHAR nameBuffer[256];
	DWORD nameBufferSize;
	TOKEN_PRIVILEGES tpOld;
	PTOKEN_PRIVILEGES ptp = (PTOKEN_PRIVILEGES)buffer;
	if (GetTokenInformation(htok, TokenPrivileges, buffer, bufferSize, &bufferSize))
	{
		for (int i=0; i<ptp->PrivilegeCount; i++)
		{
			nameBufferSize = 256;
			if (LookupPrivilegeName(NULL, &ptp->Privileges[i].Luid, nameBuffer, &nameBufferSize))
			{
				enable = toEnable;
				if (ptp->Privileges[i].Attributes & SE_PRIVILEGE_ENABLED)
				{				
					enable = false;
					_tprintf(_T("[enabled]"));
				}
				if (ptp->Privileges[i].Attributes  & SE_PRIVILEGE_USED_FOR_ACCESS)
				{
					enable = false;
					_tprintf(_T("[access]"));
				}
				if (ptp->Privileges[i].Attributes & SE_PRIVILEGE_ENABLED_BY_DEFAULT)
				{
					enable = false;
					_tprintf(_T("[default]"));								
				}
				if (ptp->Privileges[i].Attributes &SE_PRIVILEGE_REMOVED)
				{
					enable = false;
					_tprintf(_T("[removed]"));
				}
				if (enable)
				{
					if (enableTokenPrivilege(htok, nameBuffer, tpOld))
					{
						_tprintf(_T("enabled by me..."));
					}
				}


				_tprintf(_T(" [%s]\n"), nameBuffer);
				result = true;
			
			}
			else
			{
				int err  = GetLastError();
			}
		}
	}
	return result;
}

HANDLE convertPrimaryToken(HANDLE pseudoHandle)
{
	HANDLE handle = NULL;;
	DuplicateHandle(pseudoHandle, pseudoHandle, pseudoHandle, &handle, DUPLICATE_SAME_ACCESS, FALSE, DUPLICATE_SAME_ACCESS);
	return handle;
}

bool showPrivilege(bool toEnable)
{
	HANDLE handle, pseudoHandle;
	HANDLE hToken;
	TOKEN_PRIVILEGES tpOld;
	bool result =false;

	pseudoHandle = GetCurrentProcess();
	
	if ((handle = convertPrimaryToken(pseudoHandle))!= NULL)
	{		
		if (OpenProcessToken(handle, TOKEN_ALL_ACCESS, &hToken))
		{
			displayToken(hToken, toEnable);
		}
	}
	printf("\n\n");
	displayToken(hToken);
	return result;
}




int _tmain(int argc, LPTSTR* argv)
{
	TCHAR userName[MAX_PATH];
	DWORD size = MAX_PATH;
	showPrivilege(true);
	if (GetUserName(userName, &size))
	{
		_tprintf(_T("username=%s\n"), userName);
	}

	if (argc == 3)
	{
		if (_tcsicmp(argv[1], _T("display"))==0)
		{
			_tprintf(_T("before display with %s\n"), argv[2]);
			if (displayFile(argv[2]))
			{
				printf("display ok\n");
			}
		}
		else
		{
			if (_tcsicmp(argv[1], _T("create"))==0)
			{
				if (createFile(argv[2]))
				{
					printf("create ok\n");
				}
			}
		}

	}
	int i;
	scanf("%d", &i);
	return 0;
}
